# ![](./docs/images/readme/Reactotron-64.png) Reactotron

[![Slack Status](https://reactotron-slack.herokuapp.com/badge.svg)](https://reactotron-slack.herokuapp.com)

[Less Talk More Action](./docs/installing.md)

# What is Reactotron?

An OS X app for inspecting your [React JS](https://facebook.github.io/react/) and [React Native](https://facebook.github.io/react-native/) apps.

Use it to:

* view your application state
* show API requests & responses
* perform quick performance benchmarks
* subscribe to parts of your application state
* display messages similar to console.log
* track global errors with source-mapped stack traces
* dispatch actions like a government-run mind control experiment
* hot swap your app's state
* track your sagas

You plug it into your app as a dev dependency so it adds nothing to your product builds.

### Desktop

Reactotron on the left, demo React Native app on the right.

![Desktop](./docs/images/readme/reactotron-demo-app.gif)

# Documentation

* [Installing](./docs/installing.md)
* Quick start for [React JS](./docs/quick-start-react-js.md)
* Quick start for [React Native](./docs/quick-start-react-native.md)
* [Tracking errors globally](./docs/plugin-track-global-errors.md)
* Integrating with [Redux](./docs/plugin-redux.md)
* Integrating with [Redux Saga](./docs/plugin-redux-saga.md)
* Networking monitoring with [Apisauce](./docs/plugin-apisauce.md)
* [Troubleshooting](./docs/troubleshooting.md)
* [Tips and Tricks](./docs/tips.md)
* [Release Notes](https://github.com/reactotron/reactotron/releases)

#### Coming Soon

* API Docs
* Integrating with Fetch
* Creating your own plugins
* The JSON interface between client & server (coming soon...)
* What's Inside This Repo?
* Contributors Quick Start

